![Setta Logo](images/setta-github-light.png#gh-light-mode-only)
![Setta Logo](images/setta-github-dark.png#gh-dark-mode-only)


# Python Without The Donkeywork

https://github.com/user-attachments/assets/0599b754-1fbc-470b-ad6f-ac44b01da761

[![PyPI version](https://badge.fury.io/py/setta.svg)](https://badge.fury.io/py/setta)
[![License](https://img.shields.io/pypi/l/setta)](https://github.com/settadev/setta/blob/main/LICENSE)
[![Discord](https://img.shields.io/badge/Discord-Join-7389D8?logo=discord&logoColor=white)](https://discord.gg/MmHJz75bZ5)

## What does Setta do?
Setta enables you to:
- Streamline your code. 
- Skip the boilerplate parsers and frontend. 
- Effortlessly expose your Python functions as a flexible UI. 
- Configure, interact, and share with ease.

## What Setta Is Not
Setta is **not**:
- A frontend framework.
- A visual programming system.

## Why Setta Is Betta


<table>
  <tr>
    <td style="vertical-align: top; padding-right: 20px;">
      <h3>Built for Devs</h3>
      <ul>
        <li>Write your core logic wherever you want, whether that’s inside a Setta code block, or in your favorite IDE.</li>
        <li>Set your configs inside Setta, with autocompletions, type-checking, and refactoring support.</li>
        <li>Run. No config parsers needed.</li>
        <li>Auto-export your Setta projects in a Git-friendly yaml format.</li>
      </ul>
    </td>
    <td style="vertical-align: top;">
      <video src="https://github.com/user-attachments/assets/ab5786d4-cf3f-4f8d-8951-7a9fd4a9f9bf" />
    </td>
  </tr>
  <tr>
    <td style="vertical-align: top; padding-right: 20px;">
      <h3>Powerful Config Management</h3>
      <ul>
        <li>Version your configs at a granular level.</li>
        <li>Share configurations between projects.</li>
        <li>Run param sweeps across both scalar values and config versions.</li>
      </ul>
    </td>
    <td style="vertical-align: top;">
      <video src="https://github.com/user-attachments/assets/3303294e-20e7-419a-8274-57ac8e5aea92" />
    </td>
  </tr>
<tr>
    <td style="vertical-align: top; padding-right: 20px;">
      <h3>Customizable, Integrated Documentation</h3>
      Integrate your documentation, tooltips, markdown, social content, and images to make your configurations more approachable.
    </td>
    <td style="vertical-align: top;">
      <video src="https://github.com/user-attachments/assets/d08bcede-06b5-4b66-9559-c3f7574e5894" />
    </td>
  </tr>
<tr>
    <td style="vertical-align: top; padding-right: 20px;">
      <h3>Flexible UI</h3>
      <ul>
        <li>Create, organize and set your configs in a flexible drag-and-drop user interface.</li>
        <li>Utilize common UI types like sliders, color pickers, switches, and text input fields.</li>
      </ul>
    </td>
    <td style="vertical-align: top;">
      <video src="https://github.com/user-attachments/assets/8730c9f3-dbcb-47af-8290-a5d460e82e4b" />
    </td>
  </tr>
<tr>
    <td style="vertical-align: top; padding-right: 20px;">
      <h3>Monitor Long Running Scripts</h3>
      Configure your machine-learning training runs, LLM evals, and data analysis scripts.
    </td>
    <td style="vertical-align: top;">
      <video src="https://github.com/user-attachments/assets/a118f895-19c5-4d0f-bebe-4a0b594ee405" />
    </td>
  </tr>
<tr>
    <td style="vertical-align: top; padding-right: 20px;">
      <h3>Interact In Real-Time</h3>
      Inpaint your AI images and adjust data visualizations with real-time outputs in Setta.
    </td>
    <td style="vertical-align: top;">
      <video src="https://github.com/user-attachments/assets/3e04c72f-3422-40b7-ba08-328b4534ea2b" />
    </td>
  </tr>
</table>


## Installation

```
pip install setta
```

## Documentation

Documentation is in progress: https://docs.setta.dev/

## Examples

Examples showing how to use Setta will be here: https://github.com/settadev/examples


## Contributors

- [Kevin Musgrave](https://github.com/KevinMusgrave): co-creator & full-stack developer.
- [Jeff Musgrave](https://github.com/JeffMusgrave): co-creator, UI/UX developer, frontend developer, and designer.
